static const char *RcsId     = "$Header: /cvsroot/tango-ds/Instrumentation/Diffractometer/src/pseudoaxis/PseudoAxisClass.cpp,v 1.3 2008/09/24 08:37:48 piccaf Exp $";
static const char *TagName   = "$Name:  $";
static const char *HttpServer= "http://www.esrf.fr/computing/cs/tango/tango_doc/ds_doc/";
//+=============================================================================
//
// file :        PseudoAxisClass.cpp
//
// description : C++ source for the PseudoAxisClass. A singleton
//               class derived from DeviceClass. It implements the
//               command list and all properties and methods required
//               by the PseudoAxis once per process.
//
// project :     TANGO Device Server
//
// $Author: piccaf $
//
// $Revision: 1.3 $
//
// $Log: PseudoAxisClass.cpp,v $
// Revision 1.3  2008/09/24 08:37:48  piccaf
// * add dummy commandes for the Axis V2 interface
//
// Revision 1.2  2008/09/22 08:46:40  piccaf
// * add files from the new diffractometer Device
//
// Revision 1.3  2007/07/11 07:19:27  picca
// * add the "offset" and the "relativeMove" attributes  to the PseudoAxes.
// * syntax in Kappa6C
//
// Revision 1.2  2007/05/15 08:26:58  hardion
// * Merge with branch DIFFRACTO_KAPPA_6C
//
// Revision 1.1.2.2  2007/02/19 13:14:48  hardion
// * compil with rhel and test on cristal beamline
//
// Revision 1.1.2.1  2006/08/25 15:08:22  hardion
// * Merge corrections of hubert
// * Create directory for each class of device
// * Fix problem when PseudoAxis is initialized on first
// * Tested on diffabs for the communication part
//
// Revision 1.2  2006/07/06 10:29:44  hardion
// * commit to keep modification about Pseudo axis management but it doesn't work ( Error Check the wavelength)
// try to come back to old version to see if the problem persists
//
// Revision 1.1  2006/03/29 16:45:47  hardion
// * Add PseudoAxis device
// * Add DiffractometerFactory which associates Diffracto and PseudoAxis
//
//
// copyleft :   European Synchrotron Radiation Facility
//              BP 220, Grenoble 38043
//              FRANCE
//
//-=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================


#include <tango.h>

#include <PseudoAxis.h>
#include <PseudoAxisClass.h>


namespace PseudoAxis_ns
{
//+----------------------------------------------------------------------------
//
// method : 		OnCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *OnCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "OnCmd::execute(): arrived" << endl;

	((static_cast<PseudoAxis *>(device))->on());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		SetModeParametersClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *SetModeParametersClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "SetModeParametersClass::execute(): arrived" << endl;

	const Tango::DevVarDoubleStringArray	*argin;
	extract(in_any, argin);

	((static_cast<PseudoAxis *>(device))->set_mode_parameters(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		GetModeParametersClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetModeParametersClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetModeParametersClass::execute(): arrived" << endl;

	return insert((static_cast<PseudoAxis *>(device))->get_mode_parameters());
}

//+----------------------------------------------------------------------------
//
// method : 		InitializeReferencePositionCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *InitializeReferencePositionCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "InitializeReferencePositionCmd::execute(): arrived" << endl;

	((static_cast<PseudoAxis *>(device))->initialize_reference_position());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		DefinePositionCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *DefinePositionCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "DefinePositionCmd::execute(): arrived" << endl;

	Tango::DevDouble	argin;
	extract(in_any, argin);

	((static_cast<PseudoAxis *>(device))->define_position(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		ForwardCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *ForwardCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "ForwardCmd::execute(): arrived" << endl;

	((static_cast<PseudoAxis *>(device))->forward());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		BackwardClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *BackwardClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "BackwardClass::execute(): arrived" << endl;

	((static_cast<PseudoAxis *>(device))->backward());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		MotorInitCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *MotorInitCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "MotorInitCmd::execute(): arrived" << endl;

	((static_cast<PseudoAxis *>(device))->motor_init());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		StopCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *StopCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "StopCmd::execute(): arrived" << endl;

	((static_cast<PseudoAxis *>(device))->stop());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		ComputeNewOffsetCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *ComputeNewOffsetCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "ComputeNewOffsetCmd::execute(): arrived" << endl;

	Tango::DevDouble	argin;
	extract(in_any, argin);

	((static_cast<PseudoAxis *>(device))->compute_new_offset(argin));
	return new CORBA::Any();
}


//+----------------------------------------------------------------------------
//
// method : 		MotorONCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *MotorONCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "MotorONCmd::execute(): arrived" << endl;

	((static_cast<PseudoAxis *>(device))->motor_on());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		MotorOFFCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *MotorOFFCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "MotorOFFCmd::execute(): arrived" << endl;

	((static_cast<PseudoAxis *>(device))->motor_off());
	return new CORBA::Any();
}

//
//----------------------------------------------------------------
//	Initialize pointer for singleton pattern
//----------------------------------------------------------------
//
PseudoAxisClass *PseudoAxisClass::_instance = NULL;

//+----------------------------------------------------------------------------
//
// method : 		PseudoAxisClass::PseudoAxisClass(string &s)
// 
// description : 	constructor for the PseudoAxisClass
//
// in : - s : The class name
//
//-----------------------------------------------------------------------------
PseudoAxisClass::PseudoAxisClass(string &s):DeviceClass(s)
{

	cout2 << "Entering PseudoAxisClass constructor" << endl;
	set_default_property();
	write_class_property();
	get_class_property();
	
	cout2 << "Leaving PseudoAxisClass constructor" << endl;

}
//+----------------------------------------------------------------------------
//
// method : 		PseudoAxisClass::~PseudoAxisClass()
// 
// description : 	destructor for the PseudoAxisClass
//
//-----------------------------------------------------------------------------
PseudoAxisClass::~PseudoAxisClass()
{
	_instance = NULL;
}

//+----------------------------------------------------------------------------
//
// method : 		PseudoAxisClass::instance
// 
// description : 	Create the object if not already done. Otherwise, just
//			return a pointer to the object
//
// in : - name : The class name
//
//-----------------------------------------------------------------------------
PseudoAxisClass *PseudoAxisClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new PseudoAxisClass(s);
		}
		catch (bad_alloc)
		{
			throw;
		}		
	}		
	return _instance;
}

PseudoAxisClass *PseudoAxisClass::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}

//+----------------------------------------------------------------------------
//
// method : 		PseudoAxisClass::command_factory
// 
// description : 	Create the command object(s) and store them in the 
//			command list
//
//-----------------------------------------------------------------------------
void PseudoAxisClass::command_factory()
{
	command_list.push_back(new StopCmd("Stop",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new OnCmd("On",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new MotorOFFCmd("MotorOFF",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new MotorONCmd("MotorON",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new MotorInitCmd("MotorInit",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new ComputeNewOffsetCmd("ComputeNewOffset",
		Tango::DEV_DOUBLE, Tango::DEV_VOID,
		"The new user position",
		"",
		Tango::OPERATOR));
	command_list.push_back(new BackwardClass("Backward",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new ForwardCmd("Forward",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new DefinePositionCmd("DefinePosition",
		Tango::DEV_DOUBLE, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new InitializeReferencePositionCmd("InitializeReferencePosition",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new GetModeParametersClass("GetModeParameters",
		Tango::DEV_VOID, Tango::DEVVAR_DOUBLESTRINGARRAY,
		"",
		"parameters names and values",
		Tango::OPERATOR));
	command_list.push_back(new SetModeParametersClass("SetModeParameters",
		Tango::DEVVAR_DOUBLESTRINGARRAY, Tango::DEV_VOID,
		"The parameters to set",
		"",
		Tango::OPERATOR));

	//	add polling if any
	for (unsigned int i=0 ; i<command_list.size(); i++)
	{
	}
}

//+----------------------------------------------------------------------------
//
// method : 		PseudoAxisClass::get_class_property
// 
// description : 	Get the class property for specified name.
//
// in :		string	name : The property name
//
//+----------------------------------------------------------------------------
Tango::DbDatum PseudoAxisClass::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}
//+----------------------------------------------------------------------------
//
// method : 		PseudoAxisClass::get_default_device_property()
// 
// description : 	Return the default value for device property.
//
//-----------------------------------------------------------------------------
Tango::DbDatum PseudoAxisClass::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//+----------------------------------------------------------------------------
//
// method : 		PseudoAxisClass::get_default_class_property()
// 
// description : 	Return the default value for class property.
//
//-----------------------------------------------------------------------------
Tango::DbDatum PseudoAxisClass::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}
//+----------------------------------------------------------------------------
//
// method : 		PseudoAxisClass::device_factory
// 
// description : 	Create the device object(s) and store them in the 
//			device list
//
// in :		Tango::DevVarStringArray *devlist_ptr : The device name list
//
//-----------------------------------------------------------------------------
void PseudoAxisClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{

	//	Create all devices.(Automatic code generation)
	//-------------------------------------------------------------
	for (unsigned long i=0 ; i < devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
						
		// Create devices and add it into the device list
		//----------------------------------------------------
		device_list.push_back(new PseudoAxis(this, (*devlist_ptr)[i]));							 

		// Export device to the outside world
		// Check before if database used.
		//---------------------------------------------
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(device_list.back());
		else
			export_device(device_list.back(), (*devlist_ptr)[i]);
	}
	//	End of Automatic code generation
	//-------------------------------------------------------------

}
//+----------------------------------------------------------------------------
//	Method: PseudoAxisClass::attribute_factory(vector<Tango::Attr *> &att_list)
//-----------------------------------------------------------------------------
void PseudoAxisClass::attribute_factory(vector<Tango::Attr *> &att_list)
{
	//	Attribute : position
	positionAttrib	*position = new positionAttrib();
	Tango::UserDefaultAttrProp	position_prop;
	position_prop.set_label("position ");
	position_prop.set_unit("UserUnits");
	position_prop.set_description("Current position of Axis in UserUnits");
	position->set_default_properties(position_prop);
	att_list.push_back(position);

	//	Attribute : offset
	offsetAttrib	*offset = new offsetAttrib();
	Tango::UserDefaultAttrProp	offset_prop;
	offset_prop.set_label("offset");
	offset_prop.set_unit("UserUnit");
	offset_prop.set_description("The offset of the axis");
	offset->set_default_properties(offset_prop);
	offset->set_memorized();
	offset->set_memorized_init(true);
	att_list.push_back(offset);

	//	Attribute : initialized
	initializedAttrib	*initialized = new initializedAttrib();
	Tango::UserDefaultAttrProp	initialized_prop;
	initialized_prop.set_description("toggle the axis initialization. this attribut is non relevant on\nsome pseudoaxis.");
	initialized->set_default_properties(initialized_prop);
	att_list.push_back(initialized);

	//	Attribute : relativeMove
	relativeMoveAttrib	*relative_move = new relativeMoveAttrib();
	Tango::UserDefaultAttrProp	relative_move_prop;
	relative_move_prop.set_description("The relative move you want on this axis");
	relative_move->set_default_properties(relative_move_prop);
	att_list.push_back(relative_move);

	//	Attribute : mode
	modeAttrib	*mode = new modeAttrib();
	att_list.push_back(mode);

	//	Attribute : IsInitialised
	IsInitialisedAttrib	*is_initialised = new IsInitialisedAttrib();
	Tango::UserDefaultAttrProp	is_initialised_prop;
	is_initialised_prop.set_label("IsInitialised");
	is_initialised_prop.set_description("DEPRECATED");
	is_initialised->set_default_properties(is_initialised_prop);
	att_list.push_back(is_initialised);

	//	Attribute : modeNames
	modeNamesAttrib	*mode_names = new modeNamesAttrib();
	att_list.push_back(mode_names);

	//	End of Automatic code generation
	//-------------------------------------------------------------
}

//+----------------------------------------------------------------------------
//
// method : 		PseudoAxisClass::get_class_property()
// 
// description : 	Read the class properties from database.
//
//-----------------------------------------------------------------------------
void PseudoAxisClass::get_class_property()
{
	//	Initialize your default values here (if not done with  POGO).
	//------------------------------------------------------------------

	//	Read class properties from database.(Automatic code generation)
	//------------------------------------------------------------------

	//	Call database and extract values
	//--------------------------------------------
	if (Tango::Util::instance()->_UseDb==true)
		get_db_class()->get_property(cl_prop);
	Tango::DbDatum	def_prop;
	int	i = -1;


	//	End of Automatic code generation
	//------------------------------------------------------------------

}

//+----------------------------------------------------------------------------
//
// method : 	PseudoAxisClass::set_default_property
// 
// description: Set default property (class and device) for wizard.
//              For each property, add to wizard property name and description
//              If default value has been set, add it to wizard property and
//              store it in a DbDatum.
//
//-----------------------------------------------------------------------------
void PseudoAxisClass::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;

	vector<string>	vect_data;
	//	Set Default Class Properties
	//	Set Default Device Properties
	prop_name = "DiffractometerProxy";
	prop_desc = "This is the tango url to the device Diffractometer.\nN.B : The instance of the diffractometer must be the same that this PseudoAxis";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "PseudoAxisName";
	prop_desc = "This name must be register in the HKL library.\n\ni.e :\nFor Eulerian 4 circles : psi, q, q2th, th2th";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

}
//+----------------------------------------------------------------------------
//
// method : 		PseudoAxisClass::write_class_property
// 
// description : 	Set class description as property in database
//
//-----------------------------------------------------------------------------
void PseudoAxisClass::write_class_property()
{
	//	First time, check if database used
	//--------------------------------------------
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("null");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("  ");
	description << str_desc;
	data.push_back(description);
		
	//	put cvs location
	string	rcsId(RcsId);
	string	filename(classname);
	start = rcsId.find("/");
	if (start!=string::npos)
	{
		filename += "Class.cpp";
		end   = rcsId.find(filename);
		if (end>start)
		{
			string	strloc = rcsId.substr(start, end-start);
			//	Check if specific repository
			start = strloc.find("/cvsroot/");
			if (start!=string::npos && start>0)
			{
				string	repository = strloc.substr(0, start);
				if (repository.find("/segfs/")!=string::npos)
					strloc = "ESRF:" + strloc.substr(start, strloc.length()-start);
			}
			Tango::DbDatum	cvs_loc("cvs_location");
			cvs_loc << strloc;
			data.push_back(cvs_loc);
		}
	}

	//	Get CVS tag revision
	string	tagname(TagName);
	header = "$Name: ";
	start = header.length();
	string	endstr(" $");
	end   = tagname.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strtag = tagname.substr(start, end-start);
		Tango::DbDatum	cvs_tag("cvs_tag");
		cvs_tag << strtag;
		data.push_back(cvs_tag);
	}

	//	Get URL location
	string	httpServ(HttpServer);
	if (httpServ.length()>0)
	{
		Tango::DbDatum	db_doc_url("doc_url");
		db_doc_url << httpServ;
		data.push_back(db_doc_url);
	}

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("Device_4Impl");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	//--------------------------------------------
	get_db_class()->put_property(data);
}

}	// namespace
